// This script will organize your files in project panel, You can move all the specific files to their particular folders respectively, 
{
	function myScript(thisObj){
		function myScript_buildUI(thisObj){
			var myPanel = (thisObj instanceof Panel) ? thisObj : new Window("palette", "MGFX", undefined, {resizeable:true});
            var myButton = myPanel.add("button",[10,10,100,30], "Folder Structure");
            var importFile = myPanel.add("button",[10,10,100,30], "Import File");
            var movecomps = myPanel.add("button",[10,10,100,30], "Move Comps");
            var moveAi = myPanel.add("button",[10,10,100,30], "Move Vector files");
            var movepng = myPanel.add("button",[10,10,100,30], "Move Images");
            var movepsd = myPanel.add("button",[10,10,100,30], "Move PSD files");
            var moveplates = myPanel.add("button",[10,10,100,30], "Move Footages");
            var movesound = myPanel.add("button",[10,10,100,30], "Move Sound");
            var deletefolders = myPanel.add("button",[10,10,125,30], "Delete Empty Folders");
            

		    myButton.helpTip = "Create the right Directories";
			myButton.onClick = function() {
                var compFolder = false;
  for (var i = 1; i <= app.project.numItems; i++){
    if ((app.project.item(i) instanceof FolderItem) && (app.project.item(i).name == "*comps")){
      var myFolder = app.project.item(i);
      compFolder = true;
      break;
      }
  }
if(!compFolder){
    var myFolder = app.project.items.addFolder("*comps");
    }


// Second Folder
{
var aiFolder = false;
  for (var i = 1; i <= app.project.numItems; i++){
    if ((app.project.item(i) instanceof FolderItem) && (app.project.item(i).name == "ai")){
      var myaiFolder = app.project.item(i);
      aiFolder = true;
      break;
      }
  }
if(!aiFolder){
    var myaiFolder = app.project.items.addFolder("ai");
    }}

// Third Folder
{
var pngFolder = false;
  for (var i = 1; i <= app.project.numItems; i++){
    if ((app.project.item(i) instanceof FolderItem) && (app.project.item(i).name == "images")){
      var mypngFolder = app.project.item(i);
      pngFolder = true;
      break;
      }
  }
if(!pngFolder){
    var mypngFolder = app.project.items.addFolder("images");
    }
}


// Fourth Folder
{
var platesFolder = false;
  for (var i = 1; i <= app.project.numItems; i++){
    if ((app.project.item(i) instanceof FolderItem) && (app.project.item(i).name == "plates")){
      var myplatesFolder = app.project.item(i);
      platesFolder = true;
      break;
      }
  }
if(!platesFolder){
    var myplatesFolder = app.project.items.addFolder("plates");
    }
}

// Fifth Folder
{
  var soundFolder = false;
    for (var i = 1; i <= app.project.numItems; i++){
      if ((app.project.item(i) instanceof FolderItem) && (app.project.item(i).name == "sound")){
        var mysoundFolder = app.project.item(i);
        soundFolder = true;
        break;
        }
    }
  if(!soundFolder){
      var mysoundFolder = app.project.items.addFolder("sound");
      }
  }
			
 // Sixth Folder
 
{
var psdFolder = false;
  for (var i = 1; i <= app.project.numItems; i++){
    if ((app.project.item(i) instanceof FolderItem) && (app.project.item(i).name == "psd")){
      var mypsdFolder = app.project.item(i);
      psdFolder = true;
      break;
      }
  }
if(!psdFolder){
    var mypsdFolder = app.project.items.addFolder("psd");
    }
}            


}
			
        
        importFile.helpTip = "Import Files in After Effects";
        importFile.onClick = ImportFile ;
 
function ImportFile () {
 
        app.beginUndoGroup("Import File");
 
        var targetFile = File.openDialog("Import File");
       
        if (targetFile) {
                  var importOptions = new ImportOptions (targetFile);                                                                
                  app.project.importFile (importOptions);                
                }
        app.endUndoGroup();
    }
		
movecomps.helpTip = "Move all the compositions to comp folder";			
movecomps.onClick = function(){
var compFolder = null;
  for (var i = 1; i <= app.project.numItems; i++){
    if ((app.project.item(i) instanceof FolderItem) && (app.project.item(i).name == "*comps")){
      compFolder = app.project.item(i);
      break;
    }
  }

  if (compFolder == null) return;
  var comps = [];
for(var i = 1; i <= app.project.numItems; i++){
    if(app.project.item(i) instanceof CompItem)
    comps.push(app.project.item(i));
  }
  for (var i = 0; i < comps.length; i++)
        comps[i].parentFolder = compFolder;
  
  }

// Move AI/Eps Code

moveAi.helpTip = "Move all the Illustrator files to ai folder";
moveAi.onClick = function (){
var aiFolder = null;
  for (var i = 1; i <= app.project.numItems; i++){
    if ((app.project.item(i) instanceof FolderItem) && (app.project.item(i).name == "ai")){
        
      aiFolder = app.project.item(i);
      break;
    }
  }

  if (aiFolder == null) return;
  var ai = [];
for(var i = 1; i <= app.project.numItems; i++){
    var splitName = app.project.item(i).name.split(".");
    if((app.project.item(i) instanceof FootageItem) && (splitName[splitName.length-1].toLowerCase() == "ai") || (splitName[splitName.length-1].toLowerCase() == "eps"))
    ai.push(app.project.item(i));
  }
  for (var i = 0; i < ai.length; i++)
        ai[i].parentFolder = aiFolder;
  
  }

// End Code

// Move Png Code

movepng.helpTip = "Move all the Png files to png folder";
movepng.onClick = function (){
var pngFolder = null;
  for (var i = 1; i <= app.project.numItems; i++){
    if ((app.project.item(i) instanceof FolderItem) && (app.project.item(i).name == "images")){
        
      pngFolder = app.project.item(i);
      break;
    }
  }

  if (pngFolder == null) return;
  var pngs = [];
for(var i = 1; i <= app.project.numItems; i++){
    var splitName = app.project.item(i).name.split(".");
    if((app.project.item(i) instanceof FootageItem) && (splitName[splitName.length-1].toLowerCase() == "png") || (splitName[splitName.length-1].toLowerCase() == "jpg") || (splitName[splitName.length-1].toLowerCase() == "exr"))
    pngs.push(app.project.item(i));
  }
  for (var i = 0; i < pngs.length; i++)
        pngs[i].parentFolder = pngFolder;
  
  }

// End Code

// Move Sound

movesound.helpTip = "Move all the Sound files to sound folder";
movesound.onClick = function (){
var soundFolder = null;
  for (var i = 1; i <= app.project.numItems; i++){
    if ((app.project.item(i) instanceof FolderItem) && (app.project.item(i).name == "sound")){
        
      soundFolder = app.project.item(i);
      break;
    }
  }

  if (soundFolder == null) return;
  var sound = [];
for(var i = 1; i <= app.project.numItems; i++){
    var splitName = app.project.item(i).name.split(".");
    if((app.project.item(i) instanceof FootageItem) && (splitName[splitName.length-1].toLowerCase() == "wav") || (splitName[splitName.length-1].toLowerCase() == "mp3"))
    sound.push(app.project.item(i));
  }
  for (var i = 0; i < sound.length; i++)
        sound[i].parentFolder = soundFolder;
  
  }

// End Code

// Move Plates Code

moveplates.helpTip = "Move all the Footages to plates folder";
moveplates.onClick = function (){
var platesFolder = null;
  for (var i = 1; i <= app.project.numItems; i++){
    if ((app.project.item(i) instanceof FolderItem) && (app.project.item(i).name == "plates")){
        
      platesFolder = app.project.item(i);
      break;
    }
  }

  if (platesFolder == null) return;
  var plates = [];
for(var i = 1; i <= app.project.numItems; i++){
    var splitName = app.project.item(i).name.split(".");
    if((app.project.item(i) instanceof FootageItem) && (splitName[splitName.length-1].toLowerCase() == "mov") || (splitName[splitName.length-1].toLowerCase() == "mp4"))
    plates.push(app.project.item(i));
}
for (var i = 0; i < plates.length; i++)
      plates[i].parentFolder = platesFolder;

}

// End Code

// Move PSD Code

movepsd.helpTip = "Move all the PSD files to psd folder";
movepsd.onClick = function (){
  var psdFolder = null;
    for (var i = 1; i <= app.project.numItems; i++){
      if ((app.project.item(i) instanceof FolderItem) && (app.project.item(i).name == "psd")){
        psdFolder = app.project.item(i);
        break;
      }
    }
    if (psdFolder == null) return;
      var psds = [];
      for(var i = 1; i <= app.project.numItems; i++){
        var splitName = app.project.item(i).name.split(".");
        if((app.project.item(i) instanceof FootageItem) && (splitName[splitName.length-1].toLowerCase() == "psd"))
          psds.push(app.project.item(i));
      }
      for (var i = 0; i < psds.length; i++)
        psds[i].parentFolder = psdFolder;
  }

// End Code



// Delete Empty Folders Code

deletefolders.helpTip = "Delete all empty folders";
deletefolders.onClick = function removeFolders(theFolder) {
  var del = [];
    for (var i = 1; i<=app.project.numItems; i++) {
    if(app.project.item(i) instanceof FolderItem& app.project.item(i).numItems==0)
    del.push(app.project.item(i));
  }
  for (var i = 0; i < del.length; i++)
    del[i].remove();

  

  // loop from last to first item so removing a folder won't affect the index
 // for (var i = theFolder.numItems; i > 0; i--) {
 
  //if (theFolder.item(i) instanceof FolderItem) {
  // if subfolder contains items, enter recursive function again using the subfolder
  //if (theFolder.item(i).numItems > 0) removeFolders(theFolder.item(i));
 
  // if either it never contained any items, or the contents has now been removed after leaving the later recursions, delete the folder
  //if (theFolder.item(i).numItems == 0) theFolder.item(i).remove();
  //}
  //}
}
 
// enter function for the first time using the root folder
//removeFolders(app.project);


// End Code

myPanel.layout.layout(true);			
            return myPanel;
		}
	
		
		var myScriptPal = myScript_buildUI(thisObj);

		if (myScriptPal != null && myScriptPal instanceof Window){
			myScriptPal.center();
			myScriptPal.show();
		}

	}
	myScript(this);
}